PF-build.sh 50 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926927928929930931932933934935936937938939940941942943944945946947948949950951952953954955956957958959960961962963964965966967968969970971972973974975976977978979980981982983984985986987988989990991992993994995996997998999100010011002100310041005100610071008100910101011101210131014101510161017
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Do not install 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machine name> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.1.0-Build_39
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with English only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and English only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selection GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR English only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the Linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Split the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Arduino IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env GitHub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards GitHub fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modified checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers repository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for coming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have separated build environments depending on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Arduino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multi-language variants it makes it easier to find missing or unused translations.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to script commits 'git rev-list --count HEAD PF-build.sh'
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. # 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
  134. # Add argument to change build number automatically to current commit or define own number
  135. # Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
  136. # 08 Jan 2021, 3d-gussner, Comment out 'sudo' auto installation
  137. # Add '-?' '-h' help option
  138. # 27 Jan 2021, 3d-gussner, Add `-c`, `-p` and `-n` options
  139. # 12 Feb 2021, 3d-gussner, Add MK404-build.sh
  140. # 13 Feb 2021, 3d-gussner, Indentations
  141. # 13 Feb 2021, 3d-gussner, MK404 improvements like "flash" MK3, MK3S languages files to MK404 xflash.
  142. #### Start check if OSTYPE is supported
  143. OS_FOUND=$( command -v uname)
  144. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  145. linux*)
  146. TARGET_OS="linux"
  147. ;;
  148. msys*|cygwin*|mingw*)
  149. # or possible 'bash on windows'
  150. TARGET_OS='windows'
  151. ;;
  152. nt|win*)
  153. TARGET_OS='windows'
  154. ;;
  155. *)
  156. TARGET_OS='unknown'
  157. ;;
  158. esac
  159. # Windows
  160. if [ $TARGET_OS == "windows" ]; then
  161. if [ $(uname -m) == "x86_64" ]; then
  162. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  163. Processor="64"
  164. elif [ $(uname -m) == "i386" ]; then
  165. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  166. Processor="32"
  167. else
  168. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  169. echo "Please refer to the notes of build.sh$(tput sgr0)"
  170. exit 1
  171. fi
  172. # Linux
  173. elif [ $TARGET_OS == "linux" ]; then
  174. if [ $(uname -m) == "x86_64" ]; then
  175. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  176. Processor="64"
  177. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  178. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  179. Processor="32"
  180. else
  181. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  182. echo "Please refer to the notes of build.sh$(tput sgr0)"
  183. exit 1
  184. fi
  185. else
  186. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  187. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  188. echo "Read the notes of build.sh$(tput sgr0)"
  189. exit 1
  190. fi
  191. sleep 2
  192. #### End check if OSTYPE is supported
  193. #### Prepare bash environment and check if wget, zip and other needed things are available
  194. # Check wget
  195. if ! type wget > /dev/null; then
  196. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  197. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  198. exit 2
  199. fi
  200. # Check for zip
  201. if ! type zip > /dev/null; then
  202. if [ $TARGET_OS == "windows" ]; then
  203. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  204. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  205. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  206. echo "Run git Bash under Administrator privilege and"
  207. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  208. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  209. exit 3
  210. elif [ $TARGET_OS == "linux" ]; then
  211. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  212. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  213. #sudo apt-get update && apt-get install zip
  214. exit 3
  215. fi
  216. fi
  217. # Check python ... needed during language build
  218. if ! type python > /dev/null; then
  219. if [ $TARGET_OS == "windows" ]; then
  220. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  221. exit 4
  222. elif [ $TARGET_OS == "linux" ]; then
  223. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  224. echo "As Python 2.x will not be maintained from 2020 please,"
  225. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  226. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  227. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  228. #sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  229. exit 4
  230. fi
  231. fi
  232. # Check gawk ... needed during language build
  233. if ! type gawk > /dev/null; then
  234. if [ $TARGET_OS == "linux" ]; then
  235. echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
  236. echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
  237. #sudo apt-get update && apt-get install gawk
  238. exit 4
  239. fi
  240. fi
  241. #### End prepare bash / Linux environment
  242. #### Set build environment
  243. ARDUINO_ENV="1.8.5"
  244. BUILD_ENV="1.0.6"
  245. BOARD="prusa_einsy_rambo"
  246. BOARD_PACKAGE_NAME="PrusaResearch"
  247. BOARD_VERSION="1.0.3"
  248. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/package_prusa3d_index.json"
  249. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  250. BOARD_FILENAME="prusa3dboards"
  251. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  252. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  253. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  254. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  255. LIB="PrusaLibrary"
  256. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  257. # List few useful data
  258. echo
  259. echo "Script path :" $SCRIPT_PATH
  260. echo "OS :" $OS
  261. echo "OS type :" $TARGET_OS
  262. echo ""
  263. echo "Arduino IDE :" $ARDUINO_ENV
  264. echo "Build env :" $BUILD_ENV
  265. echo "Board :" $BOARD
  266. echo "Package name:" $BOARD_PACKAGE_NAME
  267. echo "Board v. :" $BOARD_VERSION
  268. echo "Specific Lib:" $LIB
  269. echo ""
  270. #### Start prepare building environment
  271. #Check if build exists and creates it if not
  272. if [ ! -d "../PF-build-dl" ]; then
  273. mkdir ../PF-build-dl || exit 5
  274. fi
  275. cd ../PF-build-dl || exit 6
  276. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  277. # Check if PF-build-env-<version> exists and downloads + creates it if not
  278. # The build environment is based on the supported Arduino IDE portable version with some changes
  279. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  280. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  281. mkdir ../PF-build-env-$BUILD_ENV
  282. sleep 5
  283. fi
  284. # Download and extract supported Arduino IDE depending on OS
  285. # Windows
  286. if [ $TARGET_OS == "windows" ]; then
  287. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  288. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  289. sleep 2
  290. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  291. echo "$(tput sgr 0)"
  292. fi
  293. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  294. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  295. sleep 2
  296. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  297. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  298. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  299. echo "$(tput sgr0)"
  300. fi
  301. fi
  302. # Linux
  303. if [ $TARGET_OS == "linux" ]; then
  304. # 32 or 64 bit version
  305. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  306. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  307. sleep 2
  308. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  309. echo "$(tput sgr 0)"
  310. fi
  311. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  312. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  313. sleep 2
  314. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  315. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  316. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  317. echo "$(tput sgr0)"
  318. fi
  319. fi
  320. # Make Arduino IDE portable
  321. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  322. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  323. fi
  324. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  325. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  326. fi
  327. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  328. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  329. fi
  330. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  331. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  332. fi
  333. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  334. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  335. fi
  336. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  337. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  338. fi
  339. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  340. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  341. fi
  342. # Change Arduino IDE preferences
  343. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  344. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  345. sleep 2
  346. echo "update.check"
  347. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  348. echo "board"
  349. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  350. echo "editor.linenumbers"
  351. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  352. echo "boardsmanager.additional.urls"
  353. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  354. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  355. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  356. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  357. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  358. echo "$(tput sgr0)"
  359. fi
  360. # Download and extract Prusa Firmware related parts
  361. # Download and extract PrusaResearchRambo board
  362. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  363. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  364. sleep 2
  365. wget $BOARD_FILE_URL || exit 9
  366. fi
  367. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  368. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  369. sleep 2
  370. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  371. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  372. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  373. fi
  374. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  375. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  376. fi
  377. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  378. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  379. fi
  380. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  381. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  382. fi
  383. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  384. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  385. echo "$(tput sgr 0)"
  386. fi
  387. # Download and extract Prusa Firmware specific library files
  388. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  389. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  390. sleep 2
  391. wget $PF_BUILD_FILE_URL || exit 11
  392. echo "$(tput sgr 0)"
  393. fi
  394. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  395. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  396. sleep 2
  397. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
  398. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  399. echo "$(tput sgr0)"
  400. fi
  401. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  402. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  403. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  404. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  405. sleep 2
  406. fi
  407. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  408. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  409. sleep 2
  410. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  411. sleep 2
  412. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  413. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  414. echo "$(tput sgr0)"
  415. fi
  416. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  417. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  418. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  419. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  420. sleep 2
  421. echo "$(tput sgr0)"
  422. exit 13
  423. fi
  424. #### End prepare building
  425. #### Start
  426. cd $SCRIPT_PATH
  427. # Check if git is available
  428. if type git > /dev/null; then
  429. git_available="1"
  430. fi
  431. while getopts v:l:d:b:o:c:p:n:m:g:?h flag
  432. do
  433. case "${flag}" in
  434. v) variant_flag=${OPTARG};;
  435. l) language_flag=${OPTARG};;
  436. d) devel_flag=${OPTARG};;
  437. b) build_flag=${OPTARG};;
  438. o) output_flag=${OPTARG};;
  439. c) clean_flag=${OPTARG};;
  440. p) prusa_flag=${OPTARG};;
  441. n) new_build_flag=${OPTARG};;
  442. m) mk404_flag=${OPTARG};;
  443. g) graphics_flag=${OPTARG};;
  444. ?) help_flag=1;;
  445. h) help_flag=1;;
  446. esac
  447. done
  448. #echo "variant_flag: $variant_flag";
  449. #echo "language_flag: $language_flag";
  450. #echo "devel_flag: $devel_flag";
  451. #echo "build_flag: $build_flag";
  452. #echo "output_flag: $output_flag";
  453. #echo "help_flag: $help_flag"
  454. #echo "clean_flag: $clean_flag"
  455. #echo "prusa_flag: $prusa_flag"
  456. #echo "new_build_flag: $new_build_flag"
  457. #
  458. # '?' 'h' argument usage and help
  459. if [ "$help_flag" == "1" ] ; then
  460. echo "***************************************"
  461. echo "* PF-build.sh Version: 1.0.6-Build_33 *"
  462. echo "***************************************"
  463. echo "Arguments:"
  464. echo "$(tput setaf 2)-v$(tput sgr0) Variant '$(tput setaf 2)All$(tput sgr0)' or variant file name"
  465. echo "$(tput setaf 2)-l$(tput sgr0) Languages '$(tput setaf 2)ALL$(tput sgr0)' for multi language or '$(tput setaf 2)EN_ONLY$(tput sgr0)' for English only"
  466. echo "$(tput setaf 2)-d$(tput sgr0) Devel build '$(tput setaf 2)GOLD$(tput sgr0)', '$(tput setaf 2)RC$(tput sgr0)', '$(tput setaf 2)BETA$(tput sgr0)', '$(tput setaf 2)ALPHA$(tput sgr0)', '$(tput setaf 2)DEBUG$(tput sgr0)', '$(tput setaf 2)DEVEL$(tput sgr0)' and '$(tput setaf 2)UNKNOWN$(tput sgr0)'"
  467. echo "$(tput setaf 2)-b$(tput sgr0) Build/commit number '$(tput setaf 2)Auto$(tput sgr0)' needs git or a number"
  468. echo "$(tput setaf 2)-o$(tput sgr0) Output '$(tput setaf 2)1$(tput sgr0)' force or '$(tput setaf 2)0$(tput sgr0)' block output and delays"
  469. echo "$(tput setaf 2)-c$(tput sgr0) Do not clean up lang build'$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  470. echo "$(tput setaf 2)-p$(tput sgr0) Keep Configuration_prusa.h '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  471. echo "$(tput setaf 2)-n$(tput sgr0) New fresh build '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  472. echo "$(tput setaf 2)-m$(tput sgr0) Start MK404 sim '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes '$(tput setaf 2)2$(tput sgr0)' with MMU2"
  473. echo "$(tput setaf 2)-g$(tput sgr0) Start MK404 grafics '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' lite '$(tput setaf 2)2$(tput sgr0)' fancy"
  474. echo "$(tput setaf 2)-?$(tput sgr0) Help"
  475. echo "$(tput setaf 2)-h$(tput sgr0) Help"
  476. echo
  477. echo "Brief USAGE:"
  478. echo " $(tput setaf 2)./PF-build.sh$(tput sgr0) [-v] [-l] [-d] [-b] [-o] [-c] [-p] [-n] [-m]"
  479. echo
  480. echo "Example:"
  481. echo " $(tput setaf 2)./PF-build.sh -v All -l ALL -d GOLD$(tput sgr0)"
  482. echo " Will build all variants as multi language and final GOLD version"
  483. echo
  484. echo " $(tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1 -c 1 -p 1 -n 1$(tput sgr0)"
  485. echo " Will build MK3S multi language final GOLD firmware "
  486. echo " with current commit count number and output extra information,"
  487. echo " not delete lang build temporary files, keep Configuration_prusa.h and build with new fresh build folder."
  488. echo
  489. exit
  490. fi
  491. #
  492. # '-v' argument defines which variant of the Prusa Firmware will be compiled
  493. if [ -z "$variant_flag" ] ; then
  494. # Select which variant of the Prusa Firmware will be compiled, like
  495. PS3="Select a variant: "
  496. while IFS= read -r -d $'\0' f; do
  497. options[i++]="$f"
  498. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  499. select opt in "${options[@]}" "All" "Quit"; do
  500. case $opt in
  501. *.h)
  502. VARIANT=$(basename "$opt" ".h")
  503. VARIANTS[i++]="$opt"
  504. break
  505. ;;
  506. "All")
  507. VARIANT="All"
  508. VARIANTS=${options[*]}
  509. break
  510. ;;
  511. "Quit")
  512. echo "You chose to stop"
  513. exit 20
  514. ;;
  515. *)
  516. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  517. ;;
  518. esac
  519. done
  520. else
  521. if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
  522. VARIANTS=$variant_flag
  523. elif [ "$variant_flag" == "All" ] ; then
  524. while IFS= read -r -d $'\0' f; do
  525. options[i++]="$f"
  526. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  527. VARIANT="All"
  528. VARIANTS=${options[*]}
  529. else
  530. echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
  531. echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
  532. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  533. echo "$(tput sgr0)"
  534. exit 21
  535. fi
  536. fi
  537. #'-l' argument defines if it is an English only version. Known values EN_ONLY / ALL
  538. #Check default language mode
  539. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  540. if [ -z "$language_flag" ] ; then
  541. PS3="Select a language: "
  542. echo
  543. echo "Which lang-build do you want?"
  544. select yn in "Multi languages" "English only"; do
  545. case $yn in
  546. "Multi languages")
  547. LANGUAGES="ALL"
  548. break
  549. ;;
  550. "English only")
  551. LANGUAGES="EN_ONLY"
  552. break
  553. ;;
  554. *)
  555. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  556. ;;
  557. esac
  558. done
  559. else
  560. if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
  561. LANGUAGES=$language_flag
  562. else
  563. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  564. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
  565. exit 22
  566. fi
  567. fi
  568. #Check if DEV_STATUS is selected via argument '-d'
  569. if [ ! -z "$devel_flag" ] ; then
  570. if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
  571. DEV_STATUS_SELECTED=$devel_flag
  572. else
  573. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  574. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
  575. exit 23
  576. fi
  577. fi
  578. #Check if Build is selected via argument '-b'
  579. if [ ! -z "$build_flag" ] ; then
  580. if [[ "$build_flag" == "Auto" && "$git_available" == "1" ]] ; then
  581. echo "Build changed to $build_flag"
  582. BUILD=$(git rev-list --count HEAD)
  583. elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
  584. BUILD=$build_flag
  585. else
  586. echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
  587. echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
  588. exit 24
  589. fi
  590. echo "New Build number is: $BUILD"
  591. fi
  592. # check if script has been started with arguments
  593. if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
  594. OUTPUT=1
  595. else
  596. OUTPUT=0
  597. fi
  598. #echo "Output is:" $OUTPUT
  599. #Check git branch has changed
  600. if [ ! -z "git_available" ]; then
  601. BRANCH=""
  602. CLEAN_PF_FW_BUILD=0
  603. else
  604. BRANCH=$(git branch --show-current)
  605. echo "Current branch is:" $BRANCH
  606. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  607. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  608. echo "created PF-build.branch file"
  609. else
  610. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  611. echo "Previous branch was:" $PRE_BRANCH
  612. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  613. CLEAN_PF_FW_BUILD=1
  614. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  615. fi
  616. fi
  617. fi
  618. #Set BUILD_ENV_PATH
  619. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 25
  620. BUILD_ENV_PATH="$( pwd -P )"
  621. cd ../..
  622. #Checkif BUILD_PATH exists and if not creates it
  623. if [ ! -d "Prusa-Firmware-build" ]; then
  624. mkdir Prusa-Firmware-build || exit 26
  625. fi
  626. #Set the BUILD_PATH for Arduino IDE
  627. cd Prusa-Firmware-build || exit 27
  628. BUILD_PATH="$( pwd -P )"
  629. #Check git branch has changed
  630. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  631. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  632. rm -r *
  633. else
  634. echo "Nothing to clean up"
  635. fi
  636. for v in ${VARIANTS[*]}
  637. do
  638. VARIANT=$(basename "$v" ".h")
  639. PRINTER=$(grep --max-count=1 "\bPRINTER_TYPE\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3 | cut -d '_' -f2)
  640. # Find firmware version in Configuration.h file and use it to generate the hex filename
  641. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  642. if [ -z "$BUILD" ] ; then
  643. # Find build version in Configuration.h file and use it to generate the hex filename
  644. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  645. else
  646. # Find and replace build version in Configuration.h file
  647. BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  648. echo "Original build number: $BUILD_ORG"
  649. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
  650. fi
  651. # Check if the motherboard is an EINSY and if so only one hex file will generated
  652. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  653. # Check development status
  654. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  655. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  656. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  657. DEV_STATUS="RC"
  658. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  659. DEV_STATUS="ALPHA"
  660. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  661. DEV_STATUS="BETA"
  662. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  663. DEV_STATUS="DEVEL"
  664. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  665. DEV_STATUS="DEBUG"
  666. else
  667. DEV_STATUS="UNKNOWN"
  668. echo
  669. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  670. PS3="Select YES only if source code is tested and trusted: "
  671. select yn in "Yes" "No"; do
  672. case $yn in
  673. Yes)
  674. DEV_STATUS="GOLD"
  675. DEV_STATUS_SELECTED="GOLD"
  676. break
  677. ;;
  678. No)
  679. DEV_STATUS="UNKNOWN"
  680. DEV_STATUS_SELECTED="UNKNOWN"
  681. break
  682. ;;
  683. *)
  684. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  685. ;;
  686. esac
  687. done
  688. fi
  689. else
  690. DEV_STATUS=$DEV_STATUS_SELECTED
  691. fi
  692. #Prepare hex files folders
  693. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  694. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 28
  695. fi
  696. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  697. #Check if exactly the same hexfile already exists
  698. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  699. echo ""
  700. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  701. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  702. if [ $OUTPUT == "1" ] ; then
  703. read -t 10 -p "Press Enter to continue..."
  704. fi
  705. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  706. echo ""
  707. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  708. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  709. if [ $OUTPUT == "1" ] ; then
  710. read -t 10 -p "Press Enter to continue..."
  711. fi
  712. fi
  713. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  714. echo ""
  715. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  716. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  717. if [ $OUTPUT == "1" ] ; then
  718. read -t 10 -p "Press Enter to continue..."
  719. fi
  720. fi
  721. #List some useful data
  722. echo "$(tput setaf 2)$(tput setab 7) "
  723. echo "Printer :" $PRINTER
  724. echo "Variant :" $VARIANT
  725. echo "Firmware :" $FW
  726. echo "Build # :" $BUILD
  727. echo "Dev Check :" $DEV_CHECK
  728. echo "DEV Status :" $DEV_STATUS
  729. echo "Motherboard:" $MOTHERBOARD
  730. echo "Languages :" $LANGUAGES
  731. echo "Hex-file Folder:" $OUTPUT_FOLDER
  732. echo "$(tput sgr0)"
  733. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  734. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  735. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
  736. else
  737. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  738. if [ $OUTPUT == "1" ] ; then
  739. read -t 10 -p "Press Enter to continue..."
  740. fi
  741. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
  742. fi
  743. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  744. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  745. # set FW_REPOSITORY
  746. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  747. #Prepare English only or multi-language version to be build
  748. if [ $LANGUAGES == "EN_ONLY" ]; then
  749. echo " "
  750. echo "English only language firmware will be built"
  751. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  752. echo " "
  753. else
  754. echo " "
  755. echo "Multi-language firmware will be built"
  756. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  757. echo " "
  758. fi
  759. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  760. # if [ $TARGET_OS == "windows" ]; then
  761. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  762. # fi
  763. #### End of Prepare building
  764. #### Start building
  765. export ARDUINO=$BUILD_ENV_PATH
  766. #echo $BUILD_ENV_PATH
  767. #export BUILDER=$ARDUINO/arduino-builder
  768. echo
  769. #read -t 5 -p "Press Enter..."
  770. echo
  771. echo "Start to build Prusa Firmware ..."
  772. echo "Using variant $VARIANT$(tput setaf 3)"
  773. if [ $OUTPUT == "1" ] ; then
  774. sleep 2
  775. fi
  776. #New fresh PF-Firmware-build
  777. if [ "$new_build_flag" == "1" ]; then
  778. rm -r -f $BUILD_PATH/* || exit 36
  779. fi
  780. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  781. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 30
  782. echo "$(tput sgr 0)"
  783. if [ $LANGUAGES == "ALL" ]; then
  784. echo "$(tput setaf 2)"
  785. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  786. echo "$(tput sgr 0)"
  787. if [ $OUTPUT == "1" ] ; then
  788. sleep 2
  789. fi
  790. cd $SCRIPT_PATH/lang
  791. echo "$(tput setaf 3)"
  792. ./config.sh || exit 31
  793. echo "$(tput sgr 0)"
  794. # Check if previous languages and firmware build exist and if so clean them up
  795. if [ -f "lang_en.tmp" ]; then
  796. echo ""
  797. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  798. if [ $OUTPUT == "1" ] ; then
  799. read -t 10 -p "Press Enter to continue..."
  800. fi
  801. echo "$(tput setaf 3)"
  802. ./lang-clean.sh
  803. echo "$(tput sgr 0)"
  804. fi
  805. if [ -f "progmem.out" ]; then
  806. echo ""
  807. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  808. if [ $OUTPUT == "1" ] ; then
  809. read -t 10 -p "Press Enter to continue..."
  810. fi
  811. echo "$(tput setaf 3)"
  812. ./fw-clean.sh
  813. echo "$(tput sgr 0)"
  814. fi
  815. # build languages
  816. echo "$(tput setaf 3)"
  817. ./lang-build.sh || exit 32
  818. # Combine compiled firmware with languages
  819. ./fw-build.sh || exit 33
  820. cp not_tran.txt not_tran_$VARIANT.txt
  821. cp not_used.txt not_used_$VARIANT.txt
  822. echo "$(tput sgr 0)"
  823. # Check if the motherboard is an EINSY and if so only one hex file will generated
  824. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  825. # If the motherboard is an EINSY just copy one hexfile
  826. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  827. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  828. # Make a copy of "lang.bin" for MK404 MK3 and MK3S
  829. if [ ! -z "$mk404_flag" ]; then
  830. cp -f lang.bin $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin
  831. fi
  832. # End of "lang.bin" for MK3 and MK3S copy
  833. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  834. else
  835. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  836. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  837. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  838. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  839. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  840. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  841. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  842. if [ $TARGET_OS == "windows" ]; then
  843. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  844. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  845. elif [ $TARGET_OS == "linux" ]; then
  846. # Make a copy for MK404 sim of MK2, MK2.5, MK2.5S firmware
  847. if [ ! -z "$mk404_flag" ]; then
  848. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  849. fi
  850. # End of MK2, MK2.5, MK2.5S firmware copy
  851. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  852. fi
  853. fi
  854. # Cleanup after build
  855. if [[ -z "$clean_flag" || "$clean_flag" == "0" ]]; then
  856. echo "$(tput setaf 3)"
  857. ./fw-clean.sh || exit 34
  858. ./lang-clean.sh || exit 35
  859. echo "$(tput sgr 0)"
  860. fi
  861. else
  862. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  863. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  864. fi
  865. # Cleanup Firmware
  866. if [[ -z "$prusa_flag" || "$prusa_flag" == "0" ]]; then
  867. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  868. fi
  869. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  870. then
  871. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  872. fi
  873. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  874. then
  875. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  876. fi
  877. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  878. then
  879. rm $SCRIPT_PATH/lang/not_tran.txt
  880. fi
  881. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  882. then
  883. rm $SCRIPT_PATH/lang/not_used.txt
  884. fi
  885. #New fresh PF-Firmware-build
  886. if [ "$new_build_flag" == "1" ]; then
  887. rm -r -f $BUILD_PATH/* || exit 36
  888. fi
  889. # Restore files to previous state
  890. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  891. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  892. if [ ! -z "$BUILD_ORG" ] ; then
  893. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
  894. fi
  895. echo $MULTI_LANGUAGE_CHECK
  896. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  897. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  898. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  899. if [ $OUTPUT == "1" ] ; then
  900. sleep 5
  901. fi
  902. done
  903. # Switch to hex path and list build files
  904. cd $SCRIPT_PATH
  905. echo "$(tput setaf 2) "
  906. echo " "
  907. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  908. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  909. #### End building
  910. #### MK404 Simulator
  911. # Check/compile MK404 sim
  912. if [ ! -z "$mk404_flag" ]; then
  913. ./MK404-build.sh
  914. # For Prusa MK2, MK2.5/S
  915. if [ "$MOTHERBOARD" == "BOARD_RAMBO_MINI_1_3" ]; then
  916. PRINTER="${PRINTER}_mR13"
  917. elif [ "$mk404_flag" == "2" ]; then # Check if MMU2 is selected only for MK3/S
  918. PRINTER="${PRINTER}MMU2"
  919. fi
  920. # Run MK404 with grafics
  921. if [ ! -z "$graphics_flag" ]; then
  922. MK404_options="--colour-extrusion --extrusion Quad_HR -g "
  923. if [ "$graphics_flag" == "1" ]; then
  924. MK404_options="${MK404_options}lite"
  925. else
  926. MK404_options="${MK404_options}fancy"
  927. fi
  928. fi
  929. # Output some useful data
  930. echo "Printer: $PRINTER"
  931. echo "Options: $MK404_options"
  932. # Change to MK404 build folder
  933. cd ../MK404/master/build
  934. # Copy language bin file for MK3 and MK3S to xflash
  935. if [ -f $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin ]; then
  936. echo "Copy 'FW$FW-Build$BUILD-$VARIANT-lang.bin' to 'Prusa_${PRINTER}_xflash.bin'"
  937. dd if=/dev/zero bs=1 count=262145 | tr "\000" "\377" >Prusa_${PRINTER}_xflash.bin
  938. dd if=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin of=Prusa_${PRINTER}_xflash.bin conv=notrunc
  939. fi
  940. # Start MK404
  941. # default with serial output and terminal to manipulate it via terminal
  942. ./MK404 Prusa_$PRINTER -s --terminal $MK404_options -f $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  943. fi
  944. #### End of MK404 Simulator